package sim.app.species;

import sim.engine.*;
import sim.portrayal.*;
import sim.util.*;
import java.util.*;

public class StationaryFood extends Entity{

	private static boolean DEFAULT_SHOW_LOOK = false;
	private static double DEFAULT_DIAMETER = 75.0;
	private static double DEFAULT_SENSE_DIST = 75.0;
	private static double DEFAULT_SPEED = 10.0;
	private static boolean[] DEFAULT_LOOK = new boolean[Entity.NUM_BITS_IN_LOOK];
	private static int DEFAULT_LIFE_SPAN = 0;

	private static int energyAddedToCreature = 500;

	public StationaryFood(MutableDouble2D initPos, MutableDouble2D initHead){

		super(initPos, initHead);

		this.setDiameter(StationaryFood.DEFAULT_DIAMETER);
		this.setShowLook(StationaryFood.DEFAULT_SHOW_LOOK);
		this.setSenseDistance(StationaryFood.DEFAULT_SENSE_DIST);
		this.setSpeed(StationaryFood.DEFAULT_SPEED);
		this.setLook(StationaryFood.DEFAULT_LOOK);
		this.setLifeSpan(StationaryFood.DEFAULT_LIFE_SPAN);

		this.resetColor();

		// WILL CHANGE!!!!!!
		this.setEnergy(StationaryFood.energyAddedToCreature);

	}

	public StationaryFood(){ super(); }

	public static void setDefaults(boolean showLook, double diameter, double speed, boolean[] look, double senseDist, int lifeSpan){

		StationaryFood.DEFAULT_SHOW_LOOK = showLook;
		StationaryFood.DEFAULT_DIAMETER = diameter;
		StationaryFood.DEFAULT_SPEED = speed;
		StationaryFood.DEFAULT_LOOK = look;
		StationaryFood.DEFAULT_SENSE_DIST = senseDist;
		StationaryFood.DEFAULT_LIFE_SPAN = lifeSpan;

	}

	public static void setEnergyAddedToCreature(int n){
		StationaryFood.energyAddedToCreature = n;
	}

	/* does nothing, because food does not move
	 **/
	public void step(SimState state){

		SpeciesSim sim = (SpeciesSim)state;

		if(this.getAge() > this.getLifeSpan()){
			sim.removeEntityFromSim(this, sim.stationaryFood);
			return;
		}

		this.incrementAge();

	}

}
